For clean Markdown of any page, append .md to the page URL. For a complete documentation index, see https://developer.shipbob.com/2025-07/api/products/llms.txt. For full documentation content, see https://developer.shipbob.com/2025-07/api/products/llms-full.txt.

# Updates multiple product variants


PATCH https://api.shipbob.com/2025-07/product/{productId}/variants
Content-Type: application/json

Reference: https://developer.shipbob.com/2025-07/api/products/updates-multiple-product-variants

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: api-2025-07
  version: 1.0.0
paths:
  /2025-07/product/{productId}/variants:
    patch:
      operationId: updates-multiple-product-variants
      summary: |
        Updates multiple product variants
      tags:
        - subpackage_products
      parameters:
        - name: productId
          in: path
          description: ''
          required: true
          schema:
            type: string
            format: int64
        - name: Authorization
          in: header
          description: Authentication using Personal Access Token (PAT) token
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Products.VariantViewModelV5Array'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/Products.UpdateProductVariantModelV5'
servers:
  - url: https://api.shipbob.com
  - url: https://sandbox-api.shipbob.com
components:
  schemas:
    Products.BaseAdditionalHazmatAttributesModel:
      type: object
      properties:
        charge_state_percentage:
          type:
            - number
            - 'null'
          format: double
        container_metal:
          type:
            - boolean
            - 'null'
        container_type:
          type:
            - string
            - 'null'
        lithium_battery_packaging:
          type:
            - string
            - 'null'
        lithium_battery_type:
          type:
            - string
            - 'null'
        magnet:
          type:
            - boolean
            - 'null'
        net_volume:
          type:
            - number
            - 'null'
          format: double
        net_weight:
          type:
            - number
            - 'null'
          format: double
      title: Products.BaseAdditionalHazmatAttributesModel
    Products.BaseBundleDefinitionModel:
      type: object
      properties:
        quantity:
          type: integer
        variant_id:
          type: integer
          format: int64
      title: Products.BaseBundleDefinitionModel
    Products.AmazonProductChannelMetadataModel:
      type: object
      properties:
        channel_id:
          type: integer
          format: int64
        channel_name:
          type:
            - string
            - 'null'
        currency:
          type:
            - string
            - 'null'
        id:
          type:
            - integer
            - 'null'
          format: int64
        is_inventory_sync_enabled:
          type: boolean
        legacy_product_id:
          type:
            - integer
            - 'null'
          format: int64
        platform:
          type:
            - string
            - 'null'
        platform_identifier:
          type:
            - string
            - 'null'
        platform_inventory_item_id:
          type:
            - string
            - 'null'
        price:
          type: number
          format: double
        seller_sku:
          type:
            - string
            - 'null'
        asin:
          type:
            - string
            - 'null'
        fnsku:
          type:
            - string
            - 'null'
        fulfillment_channel:
          type:
            - string
            - 'null'
      title: Products.AmazonProductChannelMetadataModel
    Products.BaseProductChannelMetadataModel:
      type: object
      properties:
        channel_id:
          type: integer
          format: int64
        channel_name:
          type:
            - string
            - 'null'
        currency:
          type:
            - string
            - 'null'
        id:
          type:
            - integer
            - 'null'
          format: int64
        is_inventory_sync_enabled:
          type: boolean
        legacy_product_id:
          type:
            - integer
            - 'null'
          format: int64
        platform:
          type:
            - string
            - 'null'
        platform_identifier:
          type:
            - string
            - 'null'
        platform_inventory_item_id:
          type:
            - string
            - 'null'
        price:
          type: number
          format: double
        seller_sku:
          type:
            - string
            - 'null'
      title: Products.BaseProductChannelMetadataModel
    Products.BigCommerceProductChannelMetadataModel:
      type: object
      properties:
        channel_id:
          type: integer
          format: int64
        channel_name:
          type:
            - string
            - 'null'
        currency:
          type:
            - string
            - 'null'
        id:
          type:
            - integer
            - 'null'
          format: int64
        is_inventory_sync_enabled:
          type: boolean
        legacy_product_id:
          type:
            - integer
            - 'null'
          format: int64
        platform:
          type:
            - string
            - 'null'
        platform_identifier:
          type:
            - string
            - 'null'
        platform_inventory_item_id:
          type:
            - string
            - 'null'
        price:
          type: number
          format: double
        seller_sku:
          type:
            - string
            - 'null'
        platform_product_id:
          type:
            - integer
            - 'null'
          format: int64
        platform_variant_id:
          type:
            - integer
            - 'null'
          format: int64
      title: Products.BigCommerceProductChannelMetadataModel
    Products.ShopifyProductChannelMetadataModel:
      type: object
      properties:
        channel_id:
          type: integer
          format: int64
        channel_name:
          type:
            - string
            - 'null'
        currency:
          type:
            - string
            - 'null'
        id:
          type:
            - integer
            - 'null'
          format: int64
        is_inventory_sync_enabled:
          type: boolean
        legacy_product_id:
          type:
            - integer
            - 'null'
          format: int64
        platform:
          type:
            - string
            - 'null'
        platform_identifier:
          type:
            - string
            - 'null'
        platform_inventory_item_id:
          type:
            - string
            - 'null'
        price:
          type: number
          format: double
        seller_sku:
          type:
            - string
            - 'null'
      title: Products.ShopifyProductChannelMetadataModel
    ProductsBaseProductVariantModelChannelMetadataItems:
      oneOf:
        - $ref: '#/components/schemas/Products.AmazonProductChannelMetadataModel'
        - $ref: '#/components/schemas/Products.BaseProductChannelMetadataModel'
        - $ref: '#/components/schemas/Products.BigCommerceProductChannelMetadataModel'
        - $ref: '#/components/schemas/Products.ShopifyProductChannelMetadataModel'
      title: ProductsBaseProductVariantModelChannelMetadataItems
    Products.BaseCustomsModel:
      type: object
      properties:
        country_code_of_origin:
          type:
            - string
            - 'null'
        currency:
          type:
            - string
            - 'null'
        description:
          type:
            - string
            - 'null'
        hs_tariff_code:
          type:
            - string
            - 'null'
        is321_eligible:
          type: boolean
        value:
          type:
            - integer
            - 'null'
      title: Products.BaseCustomsModel
    Products.BaseDimensionModel:
      type: object
      properties:
        height:
          type: number
          format: double
        length:
          type: number
          format: double
        width:
          type: number
          format: double
      title: Products.BaseDimensionModel
    Products.BaseSerialScanModel:
      type: object
      properties:
        exact_character_length:
          type:
            - integer
            - 'null'
        is_enabled:
          type: boolean
        prefix:
          type:
            - string
            - 'null'
        suffix:
          type:
            - string
            - 'null'
      title: Products.BaseSerialScanModel
    Products.BaseFulfillmentSettingsModel:
      type: object
      properties:
        dangerous_goods:
          type: boolean
        is_bpm_parcel:
          type: boolean
        is_case_pick:
          type: boolean
        msds_url:
          type:
            - string
            - 'null'
        requires_prop65:
          type: boolean
        serial_scan:
          $ref: '#/components/schemas/Products.BaseSerialScanModel'
      title: Products.BaseFulfillmentSettingsModel
    Products.BaseLotInformationModel:
      type: object
      properties:
        is_lot:
          type: boolean
        minimum_shelf_life_days:
          type:
            - integer
            - 'null'
      title: Products.BaseLotInformationModel
    Products.BaseReturnPreferencesModel:
      type: object
      properties:
        backup_action_id:
          type:
            - integer
            - 'null'
        instructions:
          type:
            - string
            - 'null'
        primary_action_id:
          type: integer
        return_to_sender_backup_action_id:
          type:
            - integer
            - 'null'
        return_to_sender_primary_action_id:
          type:
            - integer
            - 'null'
      title: Products.BaseReturnPreferencesModel
    Products.ReviewsPendingType:
      type: string
      enum:
        - '0'
        - '1'
        - '2'
        - '3'
        - '4'
      title: Products.ReviewsPendingType
    Products.VariantStatus:
      type: string
      enum:
        - '1'
        - '2'
        - '3'
      title: Products.VariantStatus
    Products.BarcodeModel:
      type: object
      properties:
        sticker_url:
          type:
            - string
            - 'null'
        value:
          type:
            - string
            - 'null'
      title: Products.BarcodeModel
    Products.UpdateProductVariantModelV5:
      type: object
      properties:
        additional_hazmat_attributes:
          $ref: '#/components/schemas/Products.BaseAdditionalHazmatAttributesModel'
        bundle_definition:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/Products.BaseBundleDefinitionModel'
        channel_metadata:
          type:
            - array
            - 'null'
          items:
            $ref: >-
              #/components/schemas/ProductsBaseProductVariantModelChannelMetadataItems
        customs:
          $ref: '#/components/schemas/Products.BaseCustomsModel'
        dimension:
          $ref: '#/components/schemas/Products.BaseDimensionModel'
        fulfillment_settings:
          $ref: '#/components/schemas/Products.BaseFulfillmentSettingsModel'
        gtin:
          type:
            - string
            - 'null'
        is_digital:
          type: boolean
        lot_information:
          $ref: '#/components/schemas/Products.BaseLotInformationModel'
        name:
          type:
            - string
            - 'null'
        packaging_material_type_id:
          type:
            - integer
            - 'null'
        packaging_requirement_id:
          type:
            - integer
            - 'null'
        return_preferences:
          $ref: '#/components/schemas/Products.BaseReturnPreferencesModel'
        reviews_pending:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/Products.ReviewsPendingType'
        sku:
          type:
            - string
            - 'null'
        status:
          $ref: '#/components/schemas/Products.VariantStatus'
        upc:
          type:
            - string
            - 'null'
        weight:
          type: number
          format: double
        barcodes:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/Products.BarcodeModel'
        id:
          type: integer
          format: int64
      title: Products.UpdateProductVariantModelV5
    Products.AdditionalHazmatAttributesViewModel:
      type: object
      properties:
        charge_state_percentage:
          type:
            - number
            - 'null'
          format: double
        container_metal:
          type:
            - boolean
            - 'null'
        container_type:
          type:
            - string
            - 'null'
        lithium_battery_packaging:
          type:
            - string
            - 'null'
        lithium_battery_type:
          type:
            - string
            - 'null'
        magnet:
          type:
            - boolean
            - 'null'
        net_volume:
          type:
            - number
            - 'null'
          format: double
        net_weight:
          type:
            - number
            - 'null'
          format: double
      title: Products.AdditionalHazmatAttributesViewModel
    Products.AssociatedBundlesViewModel:
      type: object
      properties:
        product_id:
          type: integer
          format: int64
        product_name:
          type:
            - string
            - 'null'
        quantity:
          type: integer
        variant_id:
          type: integer
          format: int64
        variant_sku:
          type:
            - string
            - 'null'
      title: Products.AssociatedBundlesViewModel
    Products.BundleDefinitionViewModel:
      type: object
      properties:
        product_id:
          type: integer
          format: int64
        quantity:
          type: integer
        variant_id:
          type: integer
          format: int64
        variant_name:
          type:
            - string
            - 'null'
        variant_sku:
          type:
            - string
            - 'null'
      title: Products.BundleDefinitionViewModel
    Products.CustomsViewModel:
      type: object
      properties:
        country_code_of_origin:
          type:
            - string
            - 'null'
        currency:
          type:
            - string
            - 'null'
        description:
          type:
            - string
            - 'null'
        hs_tariff_code:
          type:
            - string
            - 'null'
        is321_eligible:
          type: boolean
        value:
          type:
            - integer
            - 'null'
      title: Products.CustomsViewModel
    Products.DimensionViewModel:
      type: object
      properties:
        height:
          type: number
          format: double
        is_locked:
          type: boolean
        length:
          type: number
          format: double
        source:
          type:
            - string
            - 'null'
        unit:
          type:
            - string
            - 'null'
        width:
          type: number
          format: double
      title: Products.DimensionViewModel
    Products.SerialScanViewModel:
      type: object
      properties:
        exact_character_length:
          type:
            - integer
            - 'null'
        is_enabled:
          type: boolean
        prefix:
          type:
            - string
            - 'null'
        suffix:
          type:
            - string
            - 'null'
      title: Products.SerialScanViewModel
    Products.FulfillmentSettingsViewModel:
      type: object
      properties:
        dangerous_goods:
          type: boolean
        is_bpm_parcel:
          type: boolean
        is_case_pick:
          type: boolean
        msds_url:
          type:
            - string
            - 'null'
        requires_prop65:
          type: boolean
        serial_scan:
          $ref: '#/components/schemas/Products.SerialScanViewModel'
      title: Products.FulfillmentSettingsViewModel
    Products.InventoryViewModel:
      type: object
      properties:
        inventory_id:
          type:
            - integer
            - 'null'
        on_hand_qty:
          type: integer
      title: Products.InventoryViewModel
    Products.LotInformationViewModel:
      type: object
      properties:
        is_lot:
          type: boolean
        minimum_shelf_life_days:
          type:
            - integer
            - 'null'
      title: Products.LotInformationViewModel
    Products.MergedChildrenViewModel:
      type: object
      properties:
        channel_ids:
          type:
            - array
            - 'null'
          items:
            type: integer
            format: int64
        completed_at:
          type: string
          format: date-time
        inventory_id:
          type:
            - integer
            - 'null'
          format: int64
        variant_id:
          type: integer
          format: int64
        variant_name:
          type:
            - string
            - 'null'
      title: Products.MergedChildrenViewModel
    Products.EnumViewModel:
      type: object
      properties:
        id:
          type: integer
          format: int64
        name:
          type:
            - string
            - 'null'
      title: Products.EnumViewModel
    Products.ReturnPreferencesViewModel:
      type: object
      properties:
        backup_action:
          $ref: '#/components/schemas/Products.EnumViewModel'
        instructions:
          type:
            - string
            - 'null'
        primary_action:
          $ref: '#/components/schemas/Products.EnumViewModel'
        return_to_sender_backup_action:
          $ref: '#/components/schemas/Products.EnumViewModel'
        return_to_sender_primary_action:
          $ref: '#/components/schemas/Products.EnumViewModel'
      title: Products.ReturnPreferencesViewModel
    Products.WeightViewModel:
      type: object
      properties:
        unit:
          type:
            - string
            - 'null'
        weight:
          type: number
          format: double
      title: Products.WeightViewModel
    Products.BarcodeViewModel:
      type: object
      properties:
        sticker_url:
          type:
            - string
            - 'null'
        value:
          type:
            - string
            - 'null'
      title: Products.BarcodeViewModel
    Products.ChannelMetadataViewModel:
      type: object
      properties:
        channel_id:
          type: integer
          format: int64
        channel_name:
          type:
            - string
            - 'null'
        currency:
          type:
            - string
            - 'null'
        id:
          type: integer
          format: int64
        is_inventory_sync_enabled:
          type: boolean
        legacy_product_id:
          type:
            - integer
            - 'null'
          format: int64
        platform:
          type:
            - string
            - 'null'
        platform_identifier:
          type:
            - string
            - 'null'
        platform_inventory_item_id:
          type:
            - string
            - 'null'
        price:
          type: number
          format: double
        seller_sku:
          type:
            - string
            - 'null'
      title: Products.ChannelMetadataViewModel
    Products.AmazonChannelMetadataViewModel:
      type: object
      properties:
        channel_id:
          type: integer
          format: int64
        channel_name:
          type:
            - string
            - 'null'
        currency:
          type:
            - string
            - 'null'
        id:
          type: integer
          format: int64
        is_inventory_sync_enabled:
          type: boolean
        legacy_product_id:
          type:
            - integer
            - 'null'
          format: int64
        platform:
          type:
            - string
            - 'null'
        platform_identifier:
          type:
            - string
            - 'null'
        platform_inventory_item_id:
          type:
            - string
            - 'null'
        price:
          type: number
          format: double
        seller_sku:
          type:
            - string
            - 'null'
        asin:
          type:
            - string
            - 'null'
        fnsku:
          type:
            - string
            - 'null'
        fulfillment_channel:
          type:
            - string
            - 'null'
      title: Products.AmazonChannelMetadataViewModel
    Products.BigCommerceChannelMetadataViewModel:
      type: object
      properties:
        channel_id:
          type: integer
          format: int64
        channel_name:
          type:
            - string
            - 'null'
        currency:
          type:
            - string
            - 'null'
        id:
          type: integer
          format: int64
        is_inventory_sync_enabled:
          type: boolean
        legacy_product_id:
          type:
            - integer
            - 'null'
          format: int64
        platform:
          type:
            - string
            - 'null'
        platform_identifier:
          type:
            - string
            - 'null'
        platform_inventory_item_id:
          type:
            - string
            - 'null'
        price:
          type: number
          format: double
        seller_sku:
          type:
            - string
            - 'null'
        platform_product_id:
          type:
            - integer
            - 'null'
          format: int64
        platform_variant_id:
          type:
            - integer
            - 'null'
          format: int64
      title: Products.BigCommerceChannelMetadataViewModel
    Products.ShopifyChannelMetadataViewModel:
      type: object
      properties:
        channel_id:
          type: integer
          format: int64
        channel_name:
          type:
            - string
            - 'null'
        currency:
          type:
            - string
            - 'null'
        id:
          type: integer
          format: int64
        is_inventory_sync_enabled:
          type: boolean
        legacy_product_id:
          type:
            - integer
            - 'null'
          format: int64
        platform:
          type:
            - string
            - 'null'
        platform_identifier:
          type:
            - string
            - 'null'
        platform_inventory_item_id:
          type:
            - string
            - 'null'
        price:
          type: number
          format: double
        seller_sku:
          type:
            - string
            - 'null'
      title: Products.ShopifyChannelMetadataViewModel
    ProductsVariantViewModelV5ChannelMetadataItems:
      oneOf:
        - $ref: '#/components/schemas/Products.ChannelMetadataViewModel'
        - $ref: '#/components/schemas/Products.AmazonChannelMetadataViewModel'
        - $ref: '#/components/schemas/Products.BigCommerceChannelMetadataViewModel'
        - $ref: '#/components/schemas/Products.ShopifyChannelMetadataViewModel'
      title: ProductsVariantViewModelV5ChannelMetadataItems
    Products.VariantViewModelV5:
      type: object
      properties:
        additional_hazmat_attributes:
          $ref: '#/components/schemas/Products.AdditionalHazmatAttributesViewModel'
        associated_bundles:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/Products.AssociatedBundlesViewModel'
        bundle_definition:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/Products.BundleDefinitionViewModel'
        created_on:
          type: string
          format: date-time
        customs:
          $ref: '#/components/schemas/Products.CustomsViewModel'
        dimension:
          $ref: '#/components/schemas/Products.DimensionViewModel'
        fulfillment_settings:
          $ref: '#/components/schemas/Products.FulfillmentSettingsViewModel'
        gtin:
          type:
            - string
            - 'null'
        id:
          type: integer
          format: int64
        inventory:
          $ref: '#/components/schemas/Products.InventoryViewModel'
        is_digital:
          type: boolean
        is_image_uploaded:
          type: boolean
        lot_information:
          $ref: '#/components/schemas/Products.LotInformationViewModel'
        merge_children:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/Products.MergedChildrenViewModel'
        name:
          type:
            - string
            - 'null'
        packaging_material_type:
          $ref: '#/components/schemas/Products.EnumViewModel'
        packaging_requirement:
          $ref: '#/components/schemas/Products.EnumViewModel'
        return_preferences:
          $ref: '#/components/schemas/Products.ReturnPreferencesViewModel'
        reviews_pending:
          type:
            - array
            - 'null'
          items:
            type: string
        sku:
          type:
            - string
            - 'null'
        status:
          type:
            - string
            - 'null'
        upc:
          type:
            - string
            - 'null'
        updated_on:
          type:
            - string
            - 'null'
          format: date-time
        weight:
          $ref: '#/components/schemas/Products.WeightViewModel'
        barcodes:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/Products.BarcodeViewModel'
        channel_metadata:
          type:
            - array
            - 'null'
          items:
            $ref: >-
              #/components/schemas/ProductsVariantViewModelV5ChannelMetadataItems
      title: Products.VariantViewModelV5
    Products.VariantViewModelV5Array:
      type: array
      items:
        $ref: '#/components/schemas/Products.VariantViewModelV5'
      title: Products.VariantViewModelV5Array
  securitySchemes:
    PAT:
      type: http
      scheme: bearer
      description: Authentication using Personal Access Token (PAT) token
    OAuth2:
      type: http
      scheme: bearer
      description: OAuth2 authentication using JWT tokens

```

## SDK Code Examples

```python Products_updatesMultipleProductVariants_example
import requests

url = "https://api.shipbob.com/2025-07/product/productId/variants"

payload = {
    "additional_hazmat_attributes": {
        "charge_state_percentage": 0.1,
        "container_type": "string",
        "lithium_battery_packaging": "string",
        "lithium_battery_type": "string",
        "magnet": True,
        "net_volume": 0.1,
        "net_weight": 0.1,
        "container_metal": True
    },
    "barcodes": [
        {
            "sticker_url": "string",
            "value": "string"
        }
    ],
    "bundle_definition": [
        {
            "quantity": 0,
            "variant_id": 0
        }
    ],
    "channel_metadata": [
        {
            "asin": "string",
            "fnsku": "string",
            "fulfillment_channel": "string",
            "channel_id": 0,
            "channel_name": "string",
            "currency": "string",
            "id": 0,
            "is_inventory_sync_enabled": True,
            "legacy_product_id": 0,
            "platform": "string",
            "platform_identifier": "string",
            "platform_inventory_item_id": "string",
            "price": 0.1,
            "seller_sku": "string"
        }
    ],
    "customs": {
        "country_code_of_origin": "string",
        "currency": "string",
        "description": "string",
        "hs_tariff_code": "string",
        "is321_eligible": True,
        "value": 0
    },
    "dimension": {
        "height": 0.1,
        "length": 0.1,
        "width": 0.1
    },
    "fulfillment_settings": {
        "dangerous_goods": True,
        "is_bpm_parcel": True,
        "is_case_pick": True,
        "msds_url": "string",
        "requires_prop65": True,
        "serial_scan": {
            "exact_character_length": 0,
            "is_enabled": True,
            "prefix": "string",
            "suffix": "string"
        }
    },
    "gtin": "string",
    "id": 0,
    "is_digital": True,
    "lot_information": {
        "is_lot": True,
        "minimum_shelf_life_days": 0
    },
    "name": "string",
    "packaging_material_type_id": 0,
    "packaging_requirement_id": 0,
    "return_preferences": {
        "backup_action_id": 0,
        "instructions": "string",
        "primary_action_id": 0,
        "return_to_sender_backup_action_id": 0,
        "return_to_sender_primary_action_id": 0
    },
    "reviews_pending": [0],
    "sku": "string",
    "status": 1,
    "upc": "string",
    "weight": 0.1
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript Products_updatesMultipleProductVariants_example
const url = 'https://api.shipbob.com/2025-07/product/productId/variants';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"additional_hazmat_attributes":{"charge_state_percentage":0.1,"container_type":"string","lithium_battery_packaging":"string","lithium_battery_type":"string","magnet":true,"net_volume":0.1,"net_weight":0.1,"container_metal":true},"barcodes":[{"sticker_url":"string","value":"string"}],"bundle_definition":[{"quantity":0,"variant_id":0}],"channel_metadata":[{"asin":"string","fnsku":"string","fulfillment_channel":"string","channel_id":0,"channel_name":"string","currency":"string","id":0,"is_inventory_sync_enabled":true,"legacy_product_id":0,"platform":"string","platform_identifier":"string","platform_inventory_item_id":"string","price":0.1,"seller_sku":"string"}],"customs":{"country_code_of_origin":"string","currency":"string","description":"string","hs_tariff_code":"string","is321_eligible":true,"value":0},"dimension":{"height":0.1,"length":0.1,"width":0.1},"fulfillment_settings":{"dangerous_goods":true,"is_bpm_parcel":true,"is_case_pick":true,"msds_url":"string","requires_prop65":true,"serial_scan":{"exact_character_length":0,"is_enabled":true,"prefix":"string","suffix":"string"}},"gtin":"string","id":0,"is_digital":true,"lot_information":{"is_lot":true,"minimum_shelf_life_days":0},"name":"string","packaging_material_type_id":0,"packaging_requirement_id":0,"return_preferences":{"backup_action_id":0,"instructions":"string","primary_action_id":0,"return_to_sender_backup_action_id":0,"return_to_sender_primary_action_id":0},"reviews_pending":[0],"sku":"string","status":1,"upc":"string","weight":0.1}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Products_updatesMultipleProductVariants_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.shipbob.com/2025-07/product/productId/variants"

	payload := strings.NewReader("{\n  \"additional_hazmat_attributes\": {\n    \"charge_state_percentage\": 0.1,\n    \"container_type\": \"string\",\n    \"lithium_battery_packaging\": \"string\",\n    \"lithium_battery_type\": \"string\",\n    \"magnet\": true,\n    \"net_volume\": 0.1,\n    \"net_weight\": 0.1,\n    \"container_metal\": true\n  },\n  \"barcodes\": [\n    {\n      \"sticker_url\": \"string\",\n      \"value\": \"string\"\n    }\n  ],\n  \"bundle_definition\": [\n    {\n      \"quantity\": 0,\n      \"variant_id\": 0\n    }\n  ],\n  \"channel_metadata\": [\n    {\n      \"asin\": \"string\",\n      \"fnsku\": \"string\",\n      \"fulfillment_channel\": \"string\",\n      \"channel_id\": 0,\n      \"channel_name\": \"string\",\n      \"currency\": \"string\",\n      \"id\": 0,\n      \"is_inventory_sync_enabled\": true,\n      \"legacy_product_id\": 0,\n      \"platform\": \"string\",\n      \"platform_identifier\": \"string\",\n      \"platform_inventory_item_id\": \"string\",\n      \"price\": 0.1,\n      \"seller_sku\": \"string\"\n    }\n  ],\n  \"customs\": {\n    \"country_code_of_origin\": \"string\",\n    \"currency\": \"string\",\n    \"description\": \"string\",\n    \"hs_tariff_code\": \"string\",\n    \"is321_eligible\": true,\n    \"value\": 0\n  },\n  \"dimension\": {\n    \"height\": 0.1,\n    \"length\": 0.1,\n    \"width\": 0.1\n  },\n  \"fulfillment_settings\": {\n    \"dangerous_goods\": true,\n    \"is_bpm_parcel\": true,\n    \"is_case_pick\": true,\n    \"msds_url\": \"string\",\n    \"requires_prop65\": true,\n    \"serial_scan\": {\n      \"exact_character_length\": 0,\n      \"is_enabled\": true,\n      \"prefix\": \"string\",\n      \"suffix\": \"string\"\n    }\n  },\n  \"gtin\": \"string\",\n  \"id\": 0,\n  \"is_digital\": true,\n  \"lot_information\": {\n    \"is_lot\": true,\n    \"minimum_shelf_life_days\": 0\n  },\n  \"name\": \"string\",\n  \"packaging_material_type_id\": 0,\n  \"packaging_requirement_id\": 0,\n  \"return_preferences\": {\n    \"backup_action_id\": 0,\n    \"instructions\": \"string\",\n    \"primary_action_id\": 0,\n    \"return_to_sender_backup_action_id\": 0,\n    \"return_to_sender_primary_action_id\": 0\n  },\n  \"reviews_pending\": [\n    0\n  ],\n  \"sku\": \"string\",\n  \"status\": 1,\n  \"upc\": \"string\",\n  \"weight\": 0.1\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Products_updatesMultipleProductVariants_example
require 'uri'
require 'net/http'

url = URI("https://api.shipbob.com/2025-07/product/productId/variants")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"additional_hazmat_attributes\": {\n    \"charge_state_percentage\": 0.1,\n    \"container_type\": \"string\",\n    \"lithium_battery_packaging\": \"string\",\n    \"lithium_battery_type\": \"string\",\n    \"magnet\": true,\n    \"net_volume\": 0.1,\n    \"net_weight\": 0.1,\n    \"container_metal\": true\n  },\n  \"barcodes\": [\n    {\n      \"sticker_url\": \"string\",\n      \"value\": \"string\"\n    }\n  ],\n  \"bundle_definition\": [\n    {\n      \"quantity\": 0,\n      \"variant_id\": 0\n    }\n  ],\n  \"channel_metadata\": [\n    {\n      \"asin\": \"string\",\n      \"fnsku\": \"string\",\n      \"fulfillment_channel\": \"string\",\n      \"channel_id\": 0,\n      \"channel_name\": \"string\",\n      \"currency\": \"string\",\n      \"id\": 0,\n      \"is_inventory_sync_enabled\": true,\n      \"legacy_product_id\": 0,\n      \"platform\": \"string\",\n      \"platform_identifier\": \"string\",\n      \"platform_inventory_item_id\": \"string\",\n      \"price\": 0.1,\n      \"seller_sku\": \"string\"\n    }\n  ],\n  \"customs\": {\n    \"country_code_of_origin\": \"string\",\n    \"currency\": \"string\",\n    \"description\": \"string\",\n    \"hs_tariff_code\": \"string\",\n    \"is321_eligible\": true,\n    \"value\": 0\n  },\n  \"dimension\": {\n    \"height\": 0.1,\n    \"length\": 0.1,\n    \"width\": 0.1\n  },\n  \"fulfillment_settings\": {\n    \"dangerous_goods\": true,\n    \"is_bpm_parcel\": true,\n    \"is_case_pick\": true,\n    \"msds_url\": \"string\",\n    \"requires_prop65\": true,\n    \"serial_scan\": {\n      \"exact_character_length\": 0,\n      \"is_enabled\": true,\n      \"prefix\": \"string\",\n      \"suffix\": \"string\"\n    }\n  },\n  \"gtin\": \"string\",\n  \"id\": 0,\n  \"is_digital\": true,\n  \"lot_information\": {\n    \"is_lot\": true,\n    \"minimum_shelf_life_days\": 0\n  },\n  \"name\": \"string\",\n  \"packaging_material_type_id\": 0,\n  \"packaging_requirement_id\": 0,\n  \"return_preferences\": {\n    \"backup_action_id\": 0,\n    \"instructions\": \"string\",\n    \"primary_action_id\": 0,\n    \"return_to_sender_backup_action_id\": 0,\n    \"return_to_sender_primary_action_id\": 0\n  },\n  \"reviews_pending\": [\n    0\n  ],\n  \"sku\": \"string\",\n  \"status\": 1,\n  \"upc\": \"string\",\n  \"weight\": 0.1\n}"

response = http.request(request)
puts response.read_body
```

```java Products_updatesMultipleProductVariants_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.shipbob.com/2025-07/product/productId/variants")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"additional_hazmat_attributes\": {\n    \"charge_state_percentage\": 0.1,\n    \"container_type\": \"string\",\n    \"lithium_battery_packaging\": \"string\",\n    \"lithium_battery_type\": \"string\",\n    \"magnet\": true,\n    \"net_volume\": 0.1,\n    \"net_weight\": 0.1,\n    \"container_metal\": true\n  },\n  \"barcodes\": [\n    {\n      \"sticker_url\": \"string\",\n      \"value\": \"string\"\n    }\n  ],\n  \"bundle_definition\": [\n    {\n      \"quantity\": 0,\n      \"variant_id\": 0\n    }\n  ],\n  \"channel_metadata\": [\n    {\n      \"asin\": \"string\",\n      \"fnsku\": \"string\",\n      \"fulfillment_channel\": \"string\",\n      \"channel_id\": 0,\n      \"channel_name\": \"string\",\n      \"currency\": \"string\",\n      \"id\": 0,\n      \"is_inventory_sync_enabled\": true,\n      \"legacy_product_id\": 0,\n      \"platform\": \"string\",\n      \"platform_identifier\": \"string\",\n      \"platform_inventory_item_id\": \"string\",\n      \"price\": 0.1,\n      \"seller_sku\": \"string\"\n    }\n  ],\n  \"customs\": {\n    \"country_code_of_origin\": \"string\",\n    \"currency\": \"string\",\n    \"description\": \"string\",\n    \"hs_tariff_code\": \"string\",\n    \"is321_eligible\": true,\n    \"value\": 0\n  },\n  \"dimension\": {\n    \"height\": 0.1,\n    \"length\": 0.1,\n    \"width\": 0.1\n  },\n  \"fulfillment_settings\": {\n    \"dangerous_goods\": true,\n    \"is_bpm_parcel\": true,\n    \"is_case_pick\": true,\n    \"msds_url\": \"string\",\n    \"requires_prop65\": true,\n    \"serial_scan\": {\n      \"exact_character_length\": 0,\n      \"is_enabled\": true,\n      \"prefix\": \"string\",\n      \"suffix\": \"string\"\n    }\n  },\n  \"gtin\": \"string\",\n  \"id\": 0,\n  \"is_digital\": true,\n  \"lot_information\": {\n    \"is_lot\": true,\n    \"minimum_shelf_life_days\": 0\n  },\n  \"name\": \"string\",\n  \"packaging_material_type_id\": 0,\n  \"packaging_requirement_id\": 0,\n  \"return_preferences\": {\n    \"backup_action_id\": 0,\n    \"instructions\": \"string\",\n    \"primary_action_id\": 0,\n    \"return_to_sender_backup_action_id\": 0,\n    \"return_to_sender_primary_action_id\": 0\n  },\n  \"reviews_pending\": [\n    0\n  ],\n  \"sku\": \"string\",\n  \"status\": 1,\n  \"upc\": \"string\",\n  \"weight\": 0.1\n}")
  .asString();
```

```php Products_updatesMultipleProductVariants_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.shipbob.com/2025-07/product/productId/variants', [
  'body' => '{
  "additional_hazmat_attributes": {
    "charge_state_percentage": 0.1,
    "container_type": "string",
    "lithium_battery_packaging": "string",
    "lithium_battery_type": "string",
    "magnet": true,
    "net_volume": 0.1,
    "net_weight": 0.1,
    "container_metal": true
  },
  "barcodes": [
    {
      "sticker_url": "string",
      "value": "string"
    }
  ],
  "bundle_definition": [
    {
      "quantity": 0,
      "variant_id": 0
    }
  ],
  "channel_metadata": [
    {
      "asin": "string",
      "fnsku": "string",
      "fulfillment_channel": "string",
      "channel_id": 0,
      "channel_name": "string",
      "currency": "string",
      "id": 0,
      "is_inventory_sync_enabled": true,
      "legacy_product_id": 0,
      "platform": "string",
      "platform_identifier": "string",
      "platform_inventory_item_id": "string",
      "price": 0.1,
      "seller_sku": "string"
    }
  ],
  "customs": {
    "country_code_of_origin": "string",
    "currency": "string",
    "description": "string",
    "hs_tariff_code": "string",
    "is321_eligible": true,
    "value": 0
  },
  "dimension": {
    "height": 0.1,
    "length": 0.1,
    "width": 0.1
  },
  "fulfillment_settings": {
    "dangerous_goods": true,
    "is_bpm_parcel": true,
    "is_case_pick": true,
    "msds_url": "string",
    "requires_prop65": true,
    "serial_scan": {
      "exact_character_length": 0,
      "is_enabled": true,
      "prefix": "string",
      "suffix": "string"
    }
  },
  "gtin": "string",
  "id": 0,
  "is_digital": true,
  "lot_information": {
    "is_lot": true,
    "minimum_shelf_life_days": 0
  },
  "name": "string",
  "packaging_material_type_id": 0,
  "packaging_requirement_id": 0,
  "return_preferences": {
    "backup_action_id": 0,
    "instructions": "string",
    "primary_action_id": 0,
    "return_to_sender_backup_action_id": 0,
    "return_to_sender_primary_action_id": 0
  },
  "reviews_pending": [
    0
  ],
  "sku": "string",
  "status": 1,
  "upc": "string",
  "weight": 0.1
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Products_updatesMultipleProductVariants_example
using RestSharp;

var client = new RestClient("https://api.shipbob.com/2025-07/product/productId/variants");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"additional_hazmat_attributes\": {\n    \"charge_state_percentage\": 0.1,\n    \"container_type\": \"string\",\n    \"lithium_battery_packaging\": \"string\",\n    \"lithium_battery_type\": \"string\",\n    \"magnet\": true,\n    \"net_volume\": 0.1,\n    \"net_weight\": 0.1,\n    \"container_metal\": true\n  },\n  \"barcodes\": [\n    {\n      \"sticker_url\": \"string\",\n      \"value\": \"string\"\n    }\n  ],\n  \"bundle_definition\": [\n    {\n      \"quantity\": 0,\n      \"variant_id\": 0\n    }\n  ],\n  \"channel_metadata\": [\n    {\n      \"asin\": \"string\",\n      \"fnsku\": \"string\",\n      \"fulfillment_channel\": \"string\",\n      \"channel_id\": 0,\n      \"channel_name\": \"string\",\n      \"currency\": \"string\",\n      \"id\": 0,\n      \"is_inventory_sync_enabled\": true,\n      \"legacy_product_id\": 0,\n      \"platform\": \"string\",\n      \"platform_identifier\": \"string\",\n      \"platform_inventory_item_id\": \"string\",\n      \"price\": 0.1,\n      \"seller_sku\": \"string\"\n    }\n  ],\n  \"customs\": {\n    \"country_code_of_origin\": \"string\",\n    \"currency\": \"string\",\n    \"description\": \"string\",\n    \"hs_tariff_code\": \"string\",\n    \"is321_eligible\": true,\n    \"value\": 0\n  },\n  \"dimension\": {\n    \"height\": 0.1,\n    \"length\": 0.1,\n    \"width\": 0.1\n  },\n  \"fulfillment_settings\": {\n    \"dangerous_goods\": true,\n    \"is_bpm_parcel\": true,\n    \"is_case_pick\": true,\n    \"msds_url\": \"string\",\n    \"requires_prop65\": true,\n    \"serial_scan\": {\n      \"exact_character_length\": 0,\n      \"is_enabled\": true,\n      \"prefix\": \"string\",\n      \"suffix\": \"string\"\n    }\n  },\n  \"gtin\": \"string\",\n  \"id\": 0,\n  \"is_digital\": true,\n  \"lot_information\": {\n    \"is_lot\": true,\n    \"minimum_shelf_life_days\": 0\n  },\n  \"name\": \"string\",\n  \"packaging_material_type_id\": 0,\n  \"packaging_requirement_id\": 0,\n  \"return_preferences\": {\n    \"backup_action_id\": 0,\n    \"instructions\": \"string\",\n    \"primary_action_id\": 0,\n    \"return_to_sender_backup_action_id\": 0,\n    \"return_to_sender_primary_action_id\": 0\n  },\n  \"reviews_pending\": [\n    0\n  ],\n  \"sku\": \"string\",\n  \"status\": 1,\n  \"upc\": \"string\",\n  \"weight\": 0.1\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Products_updatesMultipleProductVariants_example
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "additional_hazmat_attributes": [
    "charge_state_percentage": 0.1,
    "container_type": "string",
    "lithium_battery_packaging": "string",
    "lithium_battery_type": "string",
    "magnet": true,
    "net_volume": 0.1,
    "net_weight": 0.1,
    "container_metal": true
  ],
  "barcodes": [
    [
      "sticker_url": "string",
      "value": "string"
    ]
  ],
  "bundle_definition": [
    [
      "quantity": 0,
      "variant_id": 0
    ]
  ],
  "channel_metadata": [
    [
      "asin": "string",
      "fnsku": "string",
      "fulfillment_channel": "string",
      "channel_id": 0,
      "channel_name": "string",
      "currency": "string",
      "id": 0,
      "is_inventory_sync_enabled": true,
      "legacy_product_id": 0,
      "platform": "string",
      "platform_identifier": "string",
      "platform_inventory_item_id": "string",
      "price": 0.1,
      "seller_sku": "string"
    ]
  ],
  "customs": [
    "country_code_of_origin": "string",
    "currency": "string",
    "description": "string",
    "hs_tariff_code": "string",
    "is321_eligible": true,
    "value": 0
  ],
  "dimension": [
    "height": 0.1,
    "length": 0.1,
    "width": 0.1
  ],
  "fulfillment_settings": [
    "dangerous_goods": true,
    "is_bpm_parcel": true,
    "is_case_pick": true,
    "msds_url": "string",
    "requires_prop65": true,
    "serial_scan": [
      "exact_character_length": 0,
      "is_enabled": true,
      "prefix": "string",
      "suffix": "string"
    ]
  ],
  "gtin": "string",
  "id": 0,
  "is_digital": true,
  "lot_information": [
    "is_lot": true,
    "minimum_shelf_life_days": 0
  ],
  "name": "string",
  "packaging_material_type_id": 0,
  "packaging_requirement_id": 0,
  "return_preferences": [
    "backup_action_id": 0,
    "instructions": "string",
    "primary_action_id": 0,
    "return_to_sender_backup_action_id": 0,
    "return_to_sender_primary_action_id": 0
  ],
  "reviews_pending": [0],
  "sku": "string",
  "status": 1,
  "upc": "string",
  "weight": 0.1
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.shipbob.com/2025-07/product/productId/variants")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```